Bug 453506 - debugedit fails under x86_64 with -gstabs+
debugedit fails under x86_64 with -gstabs+
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: rpm (Show other bugs)
rawhide
x86_64 Linux
medium Severity low
: ---
: ---
Assigned To: Panu Matilainen
Fedora Extras Quality Assurance
: Reopened, Upstream
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-07-01 00:15 EDT by David Halik
Modified: 2011-07-19 05:26 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-07-19 05:26:18 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description David Halik 2008-07-01 00:15:53 EDT
When packaging x86_64 binaries that have been compiled with "gcc -gstabs+",
find-debuginfo.sh, which calls debugedit, constantly dies while trying to strip
useful debug information:

extracting debug info from
/var/tmp/songbird-0.6.1-1.fc9-root/usr/lib64/songbird-0.6.1/xulrunner/xulrunner-bin
Failed to update file: invalid section entry size

This happens on my whole final build tree during the find-debuginfo section. I
was able to trace it back specifically to the debugedit binary that is used.
i386 seems to work fine, but if debugedit is to pass successfully in x86_64,
this flag needs to be taken out. After discussions with upstream, the devs (in
this case Mozilla) were not concerned with how they binaries were compiled, but
how debugedit operates, hence why I'm opening up this bug against it.

If a binary, or more detailed compile info is required, I can provide it.
Comment 1 hermeticos62 2009-05-09 00:13:16 EDT
See also https://bugzilla.novell.com/492390

The problem also happens with http://git.spaceboyz.net/asa.git/snapshot/asa_0.3.2.tar.bz2
If amd64/commit.asm is used (with yasm) debugedit fails with the "invalid section entry size" message, but if instead the C code is used there is no problem.
Comment 2 Bug Zapper 2009-06-09 21:51:43 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 3 Bug Zapper 2009-07-14 12:12:29 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 4 Martin Stransky 2010-10-13 09:02:48 EDT
This bug blocks firefox/thunderbird to submit crash reports directly to mozilla (instead of out bugzilla).
Comment 5 Panu Matilainen 2010-11-15 08:58:45 EST
"Perhaps" has something to do with this...

          /* TODO: Handle stabs */
#if 0
          if (strcmp (name, ".stab") == 0)
            edit_stabs (dso, i);
#endif

Somehow I doubt the generated debuginfo on ix86 is correct either even if it doesn't error out.

Roland, thoughts / comments?
Comment 6 Roland McGrath 2010-11-15 18:13:10 EST
We don't support -gstabs at all.  Various other tools won't support it either.  Packages must be built with DWARF.
Comment 7 Martin Stransky 2010-11-16 03:21:07 EST
Who is "we"? Mozilla builds its Firefox linux builds with -gstabs, it's needed for their crash reporter/database.
Comment 8 Roland McGrath 2010-11-16 06:26:41 EST
Fedora does not support non-DWARF debuginfo such as stabs.
Fedora package builds do not use it.
Comment 9 Panu Matilainen 2010-11-23 07:00:19 EST
So ... until somebody volunteers to write stabs support for debugedit, it seems best to make .stab section presence a hard error instead of failing with a cryptic message on some architectures and silently producing garbage debuginfo on others.
Comment 10 Roland McGrath 2010-11-23 15:08:27 EST
That seems reasonable to me.
Comment 11 Panu Matilainen 2011-07-19 05:26:18 EDT
rpm >= 4.9.1 now in rawhide aborts the build if stabs is used (and debuginfo generation is enabled and in strict mode, as is the default in Fedora), eg:



extracting debug info from /home/pmatilai/rpmbuild/BUILDROOT/rpm-4.9.90-0.git11184.1.fc15.x86_64/bin/rpm
Stabs debuginfo not supported: /home/pmatilai/rpmbuild/BUILDROOT/rpm-4.9.90-0.git11184.1.fc15.x86_64/bin/rpm
error: Bad exit status from /var/tmp/rpm-tmp.wJalYj (%install)

Note You need to log in before you can comment on or make changes to this bug.